from funki.refactor_recommender import RefactorRecommender

import importlib

def print_header(max_filename_length):
  name = "Name"
  duration_ms = "Duration [ms]"
  example_max_duration = " █████████████████████ 1024.567 [ms] "
  
  result ='\n'.join([
    f" Result | {name:{max_filename_length}} |{duration_ms:^{len(example_max_duration)}}| ",
    f"--------|" + "-"*max_filename_length +"|" + "-"*len(example_max_duration),
  ])
  print(result)

def test():
  rr = RefactorRecommender()
  rr.get_list_of_python_files('./src/funks')

  funk_filenames = [_ for _ in rr.python_files]
  funk_filenames.sort()

  max_filename_length = max([len(_) for _ in funk_filenames]) - 15

  for funk_filename in funk_filenames:
    module = importlib.import_module(
      funk_filename.replace('/','.').replace('..','')[:-3]
    )

    if not module.funk.test(max_filename_length):
      return False # Stop tests at first failure.
  return True # Reaching this point means all tests passed.
